package foraging_stub;

import com.cyberbotics.webots.controller.Robot;
import java.util.Random;
import bcn.Scheduler;
import bcn.coord.*;
import foraging.*;


public abstract class CtrlWanderRechargeForage_stub {
    
    protected Scheduler scheduler;
    protected Detect detect;
    protected Forage forage;
    protected Gripper gripper;
    protected Avoid avoid;
    protected Recharge recharge;
    protected PriorityCoord<Location> coordAttract;
    protected Attract attract;
    protected Repulse repulse;
    protected Wander wander;
    protected PriorityCoord<Drive.Speed> coordDrive;
    protected Drive drive;
    
    
    public abstract void setupAndRun();
    
    
    protected void connectAndRun(Robot robot) {
        connectAndRun(robot, 32);
    }
    
    
    protected void connectAndRun(Robot robot, int timeStep) {
        connectAndRun(robot, timeStep, new Random(0));
    }
    
    
    protected void connectAndRun(Robot robot, int timeStep, Random rnd) {
        // connect behaviors
        detect.get_detected().connectTo(forage.get_detected());
        gripper.get_status().connectTo(forage.get_gripperStatus());
        forage.get_gripperCmd().connectTo(gripper.get_cmd());
        forage.get_depart().connectTo(repulse.get_repulsor());
        recharge.get_homing().connectTo(coordAttract.get_in(0));
        forage.get_homing().connectTo(coordAttract.get_in(1));
        coordAttract.get_out().connectTo(attract.get_attractor());
        forage.get_drive().connectTo(coordDrive.get_in(0));
        avoid.get_drive().connectTo(coordDrive.get_in(1));
        attract.get_drive().connectTo(coordDrive.get_in(2));
        repulse.get_drive().connectTo(coordDrive.get_in(3));
        wander.get_drive().connectTo(coordDrive.get_in(4));
        coordDrive.get_out().connectTo(drive.get_speed());
        coordDrive.get_winner().connectTo(wander.get_winner());
        // run scheduler
        scheduler = new Scheduler(robot, timeStep, rnd, detect, forage, gripper, avoid, recharge, coordAttract, attract, repulse, wander, coordDrive, drive);
        scheduler.run();
    }

}
