package foraging_stub;

import com.cyberbotics.webots.controller.Robot;
import java.util.Random;
import bcn.Scheduler;
import bcn.coord.*;
import foraging.*;


public abstract class CtrlWander_stub {
    
    protected Scheduler scheduler;
    protected Avoid avoid;
    protected Wander wander;
    protected PriorityCoord<Drive.Speed> coordDrive;
    protected Drive drive;
    
    
    public abstract void setupAndRun();
    
    
    protected void connectAndRun(Robot robot) {
        connectAndRun(robot, 32);
    }
    
    
    protected void connectAndRun(Robot robot, int timeStep) {
        connectAndRun(robot, timeStep, new Random(0));
    }
    
    
    protected void connectAndRun(Robot robot, int timeStep, Random rnd) {
        // connect behaviors
        avoid.get_drive().connectTo(coordDrive.get_in(0));
        wander.get_drive().connectTo(coordDrive.get_in(1));
        coordDrive.get_out().connectTo(drive.get_speed());
        coordDrive.get_winner().connectTo(wander.get_winner());
        // run scheduler
        scheduler = new Scheduler(robot, timeStep, rnd, avoid, wander, coordDrive, drive);
        scheduler.run();
    }

}
